#include "nfc.h"
#include "TimeScreen.h"
#include "VersionScreen.h"
#include <nrfx_nfct.h>
uint32 nfc_on_count = 0;
uint32 nfc_off_count = 0;
uint32 nfc_update_count = 0;

static uint8_t m_ndef_msg_buf[1024] = {0};      /**< Buffer for NDEF file. */
static uint8_t m_ndef_msg_len;                      /**< Length of the NDEF message. */
extern void bmp_data_evt(void);
extern void nfc_reset_evt(void);
static void nfc_callback(void          * context,
                         nfc_t4t_event_t event,
                         const uint8_t * data,
                         size_t          dataLength,
                         uint32_t        flags)
{
    (void)context;

    switch (event)
    {
        case NFC_T4T_EVENT_FIELD_ON:
			nfc_on_count++;
					NRF_LOG_INFO("NFC_T4T_EVENT_FIELD_ON.");
            //bsp_board_led_on(BSP_BOARD_LED_0);
            break;

        case NFC_T4T_EVENT_FIELD_OFF:
			nfc_off_count++;
					NRF_LOG_INFO("NFC_T4T_EVENT_FIELD_OFF.");
            //bsp_board_leds_off();
            break;

        case NFC_T4T_EVENT_NDEF_READ:
					NRF_LOG_INFO("NFC_T4T_EVENT_NDEF_READ.");
            //bsp_board_led_on(BSP_BOARD_LED_3);
            break;

        case NFC_T4T_EVENT_NDEF_UPDATED:
			nfc_update_count++;
			if(nfc_update_count>=100)
			{
				nfc_reset_evt();
			}
					NRF_LOG_INFO("NFC_T4T_EVENT_NDEF_UPDATED.%x%x%x",data[0],data[1],data[2]);
           // if (dataLength > 0)
            {
			ret_code_t err_code;
				//NRF_LOG_HEXDUMP_INFO(data, dataLength);
			m_ndef_msg_len = dataLength;
			if(data[1] == 0xff)
			{
				set_standby();
			}
			else if(data[1] == 0x00)
			{
				out_standby();
			}
			//Set_bmp_index(data[1]);
			bmp_data_evt();
            }
            break;

        default:
            break;
    }
}
uint8 nfc_id[7] = {0};
void init_nfc_t4t(uint8_t* mac)
{
	ret_code_t err_code;

	/* Set up NFC */
	err_code = nfc_t4t_setup(nfc_callback, NULL);
	APP_ERROR_CHECK(err_code);

	/* Run Read-Write mode for Type 4 Tag platform */
	err_code = nfc_t4t_ndef_rwpayload_set(m_ndef_msg_buf, sizeof(m_ndef_msg_buf));
	APP_ERROR_CHECK(err_code);

	NRF_LOG_INFO("Writable NDEF message example started.");

	
	memcpy(nfc_id,mac,6);
	nfc_t4t_parameter_set(NFC_T4T_PARAM_NFCID1,nfc_id,7);

	/* Start sensing NFC field */
	err_code = nfc_t4t_emulation_start();
	APP_ERROR_CHECK(err_code);
}


/**
 * @brief Callback function for handling NFC events.
 */
